%% this plots tha rates in Hz, upposed porb per attempt, that other verisions plot
clear all
fsep = filesep;
close all;
g = -log10(0.36*0.42*0.9)/50%

N = 200;
Lmax = 300;

MemLim =  190; %memeory steps limit
P0 = 0.018 
C = 2.997e5/1.4682;
Tdetection = 1e-6*(2000+107+12.2+11.94+3+12+10+1); %s, see sequence file

Include_Detection_Time = 0;
%% Repeater exp
%R_exp = events/att; % per chanel use
datt = '2021_03_11';

timetag_root = ['data' fsep  'timetags_other' fsep  ];
file = '2021_03_11_220540';
'Repeater configuration:'
[events, att, T1, eff_sigle_photon(1),T_per_att_pure]= rates_experiment(['preprocessed' fsep 'all_' file '.mat'], [timetag_root, file, '.txt'], Include_Detection_Time);  % 25+25 km rep  
R_exp(1) = events/(T1); 
R_exp_err(1) = sqrt(events)/T1;


%% direct transmission exp
Calculate_Pure = 1; % to extract only the purified rate
'Direct transmission configuration:'
rates_experiment_direct
R_exp_direct = (Counts)./(T);
R_exp_direct_err = sqrt(Counts)./T;


%due to darc counts:
err_direct_p = log10((R_exp_direct+R_exp_direct_err)/2)-log10(R_exp_direct/2);
err_direct_m = -log10((R_exp_direct-R_exp_direct_err)/2)+log10(R_exp_direct/2);

close(figure(8))
figure(8)
hold on

%% theory 
Photon_gen_time = T_per_att_pure*1e-6-2*25/C % T1/att-2*25/C 
Photon_gen_time_dir = (T_per_att*1e-6-4*25/C )%(T(1)./Attempts(1)-4*25/C )

R_exp = 1/(1/R_exp+Tdetection)
R_exp_direct = 1/(1/R_exp_direct+Tdetection)
for i = 1:N
    L(i) = Lmax*i/N;
%% plot rate per attemt R
    R_direct_with_poton(i) = 2*P0*10^(-g*L(i)) / (2*L(i)/C+Photon_gen_time_dir ); %include 2-photon gen. time
     R_direct_with_poton(i) = 1/(1/R_direct_with_poton(i)+Tdetection);  %correcting for the detection time theory
    
    R_direct_maxt(i)= 2*-log2(1-10^(-g*L(i))) *C/(2*L(i));

    Psm = P0*10^(-g*L(i)/2);
    R_inf_mem(i) = Psm*(2-Psm)/(3-2*Psm) *C/(L(i));
    [Step_mem(i), testsum(i)] = Rate_limited_mem(Psm, MemLim);
    
    R_step_mem_with_poton(i) = Step_mem(i) / (L(i)/C+Photon_gen_time );  %include photon gen. time
     R_step_mem_with_poton(i) = 1/(1/ R_step_mem_with_poton(i)+Tdetection);
    %---

    
%% plot rate in Hz - R figured
end;

%plot(L, (R_direct_maxt), 'LineWidth', 3, 'LineStyle', '-.' ,'Color', 'black', 'DisplayName','Theoretical max TGW')
Xr = L'./L';
s = shadedErrorBar(L, R_direct_maxt, [Xr*1000,Xr-1 ] );
set(s.mainLine, 'LineWidth', 3, 'LineStyle', '-' ,'Color', 'black', 'DisplayName','Repeaterless bound SKR_{bound}')
set( s.edge, 'LineStyle', 'none') 
set( s.patch, 'FaceColor', 'black', 'FaceAlpha', 0.3)

label = 'Experiment repeater no PBSs';
label = 'Experiment RKR current repeater';
pe = errorbar([50], (R_exp(1)), 1./R_exp(1).*R_exp_err(1)/log(10), 'Color','blue' , 'Marker', 'o', 'MarkerSize', 8, 'LineWidth', 1, 'LineStyle', 'none',... %[0.75, 0, 0.75]
    'DisplayName', label);

label = ['Theory memory ', num2str(MemLim), ' steps with \tau = 2L/c+t_0. P_0=',  num2str(P0) ' t_0 = ' num2str(1e6*Photon_gen_time) '\mus'];
label = 'Model RKR current repeater';
plot(L, ( R_step_mem_with_poton), 'Color',pe.Color,'LineWidth', 2, 'LineStyle', '-.', ...
    'DisplayName',  label)

label = 'Expeiment direct no PBSs 2 qubits';
label = 'Experiment RKR current direct';
ped = errorbar([50], (R_exp_direct(1)), err_direct_p(1) , err_direct_m(1) ,'Color',[0.47, 0.67, 0.19] ,  'Marker', 'o', 'MarkerSize', 8, 'LineWidth', 1, 'LineStyle', 'none', ...
    'DisplayName',label);

label = ['Theory direct link 2 qubits with \tau = 2L/c+t_0. P_0=',  num2str(P0) ' t_0 = ' num2str(1e6*2*Photon_gen_time) '\mus' ];
label = 'Model RKR current direct';
plot(L, ( R_direct_with_poton), 'Color',ped.Color,'LineWidth', 2, 'LineStyle', '-.', ...
    'DisplayName',  label)



grid on


xlabel('Telecom fiber channel length L (km)') %['Total distance with ' num2str(10*g) ' dB/km att (km)']
ylabel('Rate (s^{-1})','Interpreter','tex')
%title(['Success rate during attempts'])

Eff_sigle_photon_repeater = eff_sigle_photon(1)
Efficiency_direct  = Counts(1)/attempts(1)

xlim([1,220])
ylim([5e-3,140])
set(gca, 'YScale', 'log')
set(findall(gcf,'-property','FontSize'),'FontSize',12)
% 
% R_exp
% R_exp_direct
