%% Parameters for addressed exp

clear all
clear out
clear timetag_bases ; clear tricsfolder_arr; clear timetag_files
close all
fsep = filesep;


H = 1; D = 2; R = 3; V = 4; A = 5; L = 6; 
 
%%   qfc machine:
%server_path =['Z:']% fsep 'measurements' fsep 'QFC' fsep '2020_11_18' fsep
%% Victor's laptop:
server_path = 'data';


%% set this section

date = '2021_03_20';
timetag_root = [server_path fsep 'photon_timetags_repeater' ];
trics_root_folder = [server_path fsep  'ion_measurements_repeater'];

ttt = dir([trics_root_folder ]);
ttg = dir([timetag_root  ]);

k = 1;
for i = 3:length(ttt)
        tricsfolder_arr{i-2} = [trics_root_folder  fsep ttt(i).name];
        timetag_files{i-2} = [timetag_root fsep ttg(i).name];
end
imax = i-2;

% timetag_root = [server_path fsep 'measurements' fsep 'QFC' fsep datt fsep 'ttg1' ];
% trics_root_folder = [server_path fsep  'measurements'  fsep fsep 'QFC' fsep datt fsep 'trics1'];
ttt = dir([trics_root_folder ]);
ttg = dir([timetag_root  ]);
% for i = 3:length(ttt)
%         tricsfolder_arr{imax+i-2} = [trics_root_folder fsep ttt(i).name];
%         timetag_files{imax+i-2} = [timetag_root  fsep ttg(i).name];
% end

trics_root_folder = [];
timetag_root = [];
timetag_bases= [...
H H; H V; V V; V H;...
H D; H A; V A; V D;...
H R; H L; V L; V R;...

D H; D V; A V; A H;...
D D; D A; A A; A D;...
D R; D L; A L; A R; ...

R H; R V; L V; L H; ...
R D; R A; L A; L D; ...
R R; R L; L L; L R;
]; 
 % timetag_bases = [timetag_bases;timetag_bases];
bases2 = [timetag_bases(:,2),timetag_bases(:,1)]; %exchange bases

%CYCLES!!


%% setting parameters
threshold = 1.2e5;         %camera
doppler_threshold = 80;   %dopplerPMT
seq_cycles = 40; 


wavepacket_start = 132%69   %from chRaman (3)
wavepacket_stop =  wavepacket_start+41

gate2_shift = 0;    %from chRaman2 (0), relative delay wrt wavepacket_satrt
gates_bins_number = 1;


nloops_param =  [29, 190];% for tests, total loops 
loop_starts  = [1];
loop_ends = [190];
points_sel = 0;

%chennels on the timetagger
ChRamans = [0,3]; %0 Zero
ChRaman2s = [3,0]; %3
ChAPD1s = [2,6];% 2 %two
ChAPD2s =[6,2]; % 6
ChCycle =7;
%timetag_bases = bases2

%% extracting data
for ion_in_memory = 1:2  % sweep which ion is in memory
    ChRaman = ChRamans(ion_in_memory);
    ChRaman2 = ChRaman2s(ion_in_memory);
    ChAPD1 = ChAPD1s(ion_in_memory);
    ChAPD2 = ChAPD2s(ion_in_memory);
    for lp_sel = 1:length(loop_starts) %sweep selection of loops if needed
         clear out
        save_to_file_name = ['preprocessed' fsep date 'set2_MemRamTr_' int2str(ChRaman) '_l_' int2str(loop_starts(lp_sel)) 'to' int2str(loop_ends(lp_sel)) ];
        % 
        %% indirect parameters
        wavepacket_ROI = wavepacket_stop - wavepacket_start;
        gate_length = wavepacket_ROI/gates_bins_number;
        gate_start{1} = wavepacket_start;
        gate_stop{1} = gate_start{1} + gate_length;

        for ii = 2:gates_bins_number
            gate_start{ii} = gate_start{ii-1} + gate_length;
            gate_stop{ii} = gate_start{ii} + gate_length;
        end
        % for iii = 1:length( timetag_files)
        %     timetag_files{iii}= [datt '_' timetag_files{iii} '.txt'];
        % end
        clear H V D A R L;
        for jj = 1:gates_bins_number
            out{jj} = timetags_cam_2ion_2phot_memory_conditional(...
                timetag_root, trics_root_folder, tricsfolder_arr,  timetag_files, ...
                timetag_bases, ChRaman,ChRaman2, ChAPD1, ChAPD2, ChCycle, threshold, doppler_threshold, ...
                seq_cycles,  gate_start{jj}, gate_stop{jj}, gate2_shift, jj, nloops_param,...
                [loop_starts(lp_sel):loop_ends(lp_sel)], points_sel);
            %use additional 'points_sel' parameter to select a part of
            %measured data
            
             %check = check_trics_timetags(timetag_root, trics_root_folder, tricsfolder_arr,  timetag_files, timetag_bases, ChRaman, ChAPD1, ChAPD2, ChCycle, threshold, doppler_threshold, seq_cycles,  gate_start{jj}, gate_stop{jj}, delay_to_second, jj, 1);
            %% plotting check

        end
        close all

        %% merge out-structures into one

        f = fieldnames(out{gates_bins_number});

        for ii = 1:length(f)
            for jj = 1: length( out{gates_bins_number}.(f{ii}) )
                if isempty(out{gates_bins_number}.(f{ii}){jj})
                  out{gates_bins_number}.(f{ii})(jj) = out{jj}.(f{ii})(jj);
                end
            end
        end

        out = out{gates_bins_number};
        out.photon_bases = timetag_bases;
        out.loop_starts= loop_starts(lp_sel);
        out.loop_ends = loop_ends(lp_sel);
        figure()
        hold on
        histogram(out.Counts1{1}(:,1), [0:500]);
        histogram(out.Counts2{1}(:,1), [0:500]);
         te = zeros(10, 17);
         toplot = out.state{1}./out.tomo_matrix_attempts1{1}*1e4;
         toplot(find(isnan(toplot))) = 0;
         te(1:9, 1:16) =  toplot;
         figure
         surface( te, 'FaceColor', 'flat');

        save([save_to_file_name '.mat'],'out');
    end
    %doTomo_cumulative_swap(save_to_file_name )
end
