
fsep = filesep;
addpath('sub_routines');
%===========================================Sept 3 ===================
% this scripts works with a newr measurements that have normalization
% attempt right after HOM attemtrat

%to have trigger at each pulse changed trigger channel to '3' in:
% analyse_counts.m                         for singles
% analyse_coincidendes.m AND gated.m       for coincidences
%change it back if you want triger for each cylce instead

%%
%defining data location:
% Set the correct path to the network storage of timetag files as it is  mounted on your machine
% Set correct folder for data
% You can chose several files and get averaged data as well as singles.
% Keep in mind that ~100 MBt timetag files take a wile to load, do itonly once.

datt = '2021_03_11';
 
timetag_root = [ 'data' fsep 'timetags_other' fsep ];

%% 



timetag_file_array = {'224720'}% direct. CH 6 . 50 km
 Rabi_freq = 0;


for iii = 1:length( timetag_file_array)
    timetag_file_array{iii}= [datt '_' timetag_file_array{iii} '.txt']; %'clean_tags_'
end
%  


%% loop over timetags files and setting exp parameters---------------------
Total_attempts = 0;
MaxFile = length(timetag_file_array) ; 

dt =16   ;        % time step for the wavepackets and integrated curves.
binwidths = [1];
histlength = 4000;   % length of the histograms in us %trigger each loop  %histlength = 20000; %triger each cycle
gate = [-10 0];  % gate for the photons that are overlapped - blue lines on plot;        %gate = [3231 3269]  %triiger each cycle     
gate_disting_ = {125+132+[0,0+60],250+125+132+[0,0+60]};%  gate {1st,2nd}files         % gate for the first of reference photon (long path)  - red lines on plots
TriggerCH = 0;
det_CH = {6,2}; % clicks channels  
delay_disting =60;                                      % additional delay between 1st(long) and 2nd(short) ref. photons 
w = 30; 

;                                       %length in us of the window used to estimate the noise floor (green lines on plot)
noise_del = 120;                                          % ROI for noise counts wrt gate
         % number of Monte Carlo realizations. Need to have poissrnd function to make it working. see poissrnd1.m 
subtract_noise =1;      % 1 = do noise  subtraction 
    

for nfile = 1:MaxFile           %loops for several files
     nfile;
     %----------------------analysis params----------------------------
    
    maxdel = 2*histlength;
    bin_arr = -histlength:dt:histlength;
    gate_disting = gate_disting_{nfile};
    noise_window = gate_disting(2)-gate_disting(1); 
    CH = det_CH{nfile};
  
    
    [gate_stop_bin, gate_start_bin, gate_length, zer] = bin_numbers_from_gate(bin_arr, gate); %search gate inicies-------
    timetag_file = timetag_file_array{nfile};                                                 %load files
    filename = strcat(timetag_root, timetag_file)
    
    %ON!! then back off to avoid reloading
    TAGS_HOM{nfile} = (load_tags(filename)); uncomment_previous_line =1;             %!!!!!!!!UNCOMMENT IT
    uncomment_previous_line;
    
    gate_len_us = gate(2)-gate(1);
    
    
    channeldata1_converted = analyse_counts(TAGS_HOM{nfile}, CH,   histlength,TriggerCH ); %2
    %channeldata2_converted = analyse_counts(TAGS_HOM{nfile}, 2, histlength,TriggerCH );  %6
    attempts(nfile) = channeldata1_converted.attempts;
    
    It = 1;
    figure(It+100*nfile)
    ch1 = histogram(channeldata1_converted.time_diff, bin_arr);
    hold on
    xlabel('Time delay, us')
    ylabel('Counts per per bin')
    title(sprintf('CH %d first run %.1f us bin, %.1e raman pulses file %d',CH, dt,channeldata1_converted.attempts, nfile ))
    xlim([0 histlength])
    grid on
    draw_gate(gate, It+100*nfile, 'blue') 
    draw_gate(gate_disting, It+100*nfile, 'red') 
    draw_gate(gate_disting+delay_disting, It+100*nfile, 'red') 
    [Counts1, attempts1, nois_counts1, eff_long(It, nfile), noise_prob_long(It, nfile)] =efficiency_from_hystogram4(ch1.BinCounts, It+100*nfile, channeldata1_converted.attempts, gate_disting, bin_arr, noise_del, noise_window,   subtract_noise);
    [Counts2, attempts2,  nois_counts2, eff_short(It, nfile), noise_prob_short(It, nfile)] =efficiency_from_hystogram4(ch1.BinCounts, It+100*nfile,channeldata1_converted.attempts, gate_disting+delay_disting, bin_arr, noise_del, noise_window,   subtract_noise);
    Counts(nfile) = Counts1+Counts2;
    Noise_counts(nfile) = nois_counts1+nois_counts2;
    Attempts(nfile) = attempts1;
    T_tot(nfile)= (TAGS_HOM{nfile}(end,1)-TAGS_HOM{nfile}(1,1))/1e6;  % total time in sec
    %pure attempts time:
    if(Calculate_Pure)
        A = find(TAGS_HOM{nfile}(:, 2) == 0);
        test = TAGS_HOM{nfile}( A(:),1);
        test2 = test(2:end); test2(end+1)=test2(end);
        %Period = median(test2-test); 
        %T(nfile) = Period*length(A)/1e6;  % get total time as number of attempts* duration of one , in seconds . length(A)==Attempts(nfile)
         H =histogram(test2-test, 100:1:1000);
         [m, i] = max(H.BinCounts);
        T_per_att =H.BinEdges(i); %sum(H.BinCounts.*H.BinEdges(1:end-1))/length(A); % average time per att, us, estimated by ion1 first
        f = gcf;
        close(f);
        clear H
        H = histogram(test2-test, 5000:10:30000); % plot histogram to find the time needed to reinitialize after the state detection
        [m, i] = max(H.BinCounts); % find the element that is detection time
        T_detection = H.BinEdges(i); % this is our state detection/reinitialization time in us (~10 ms)
        %T_detection*events/1e6 gives 29s or 1/10th of of the time even with 10
        %ms reinitialization
        T = T_per_att*Attempts(nfile)/1e6 + T_detection*Counts(nfile)/1e6*Include_Detection_Time; %total time for all attempts, in sec
        
        %T = time+ T_detection*events/1e6*Include_Detection_Time; % gives almost the same result. More exact for the 50 km data. COnstant time per loop comes from just above

    else
        T(nfile) = T_tot(nfile);
    end
    fprintf('Time = %f s ; raw rate =  %f +- %f photons/s \n',  T_tot(nfile), Counts(nfile)/ T_tot(nfile), sqrt(Counts(nfile))/ T_tot(nfile))
    close( figure(It+100*nfile))
end;


%------------------------------------------
